<?php

namespace Bill\Lib;

use Dever;

class Cash
{
    public function up($mid, $type, $cash, $role, $type_id, $desc, $status)
    {
        $member = Dever::db('agent/member')->find(array('id' => $mid, 'clear' => true));
        if ($member['status'] <= 2) {
        	$where['mid'] = $mid;
            if ($type == 11) {
                $cash = -1*$cash;
            }
        	$where['type'] = $type;
        	$where['type_id'] = $type_id;
        	$where['clear'] = true;
        	$info = Dever::db('bill/cash')->find($where);
        	if (!$info) {
        		$data = $where;
        		$data['order_num'] = $this->getOrderId();
        		$data['yue'] = $member['cash'] + $cash;
        		$data['cash'] = $cash;
        		$data['role'] = $role;
        		$data['desc'] = $desc;
        		$data['status'] = $status;
                if ($status == 2) {
                    $data['operdate'] = time();
                }
        		return Dever::db('bill/cash')->insert($data);
        	}
            return $info['id'];
        }

        return false;
    }

    /**
     * 生成订单号
     *
     * @return mixed
     */
    public function getOrderId()
    {
        $where['order_num'] = Dever::order('C');
        $state = Dever::db('bill/cash')->one($where);
        if (!$state) {
            return $where['order_num'];
        } else {
            return $this->getOrderId();
        }
    }

    # 展示详情
    public function show()
    {
        $id = Dever::input('id');

        $config = Dever::db('bill/cash')->config['set'];

        $info = Dever::db('bill/cash')->one($id);

        $status = $config['status'][$info['status']];

        $type = $config['type'][$info['type']];

        $member = Dever::db('agent/member')->find($info['mid']);
        $role = Dever::db('setting/role')->one($member['role']);
        $level = Dever::db('setting/level')->one($member['level_id']);

        if ($member['shop_id']) {
            $shop = Dever::db('shop/info')->one($member['shop_id']);
        } else {
            $shop['id'] = -1;
            $shop['name'] = '无';
        }

        $cdate = date('Y-m-d H:i', $info['cdate']);
        if ($info['operdate']) {
            $opertime = date('Y-m-d H:i', $info['operdate']);
        } else {
            $opertime = '';
        }

        $result = array();

        $result['代理商信息'] = array
        (
            'type' => 'info',
            'content' => array
            (
                array
                (
                    array('代理商', $member['name'] . ' ' . $member['mobile']),
                    array('代理角色', $role['name'] . ($level ? '（'.$level['name'].'）' : '')),
                    array('所属店铺', $shop['name']),
                ),

                array
                (
                    array('资金余额', '¥' . $member['cash'] . '元'),
                    array('直推业绩', '¥' . $member['sell'] . '元'),
                    array('团队业绩', '¥' . $member['group_sell'] . '元'),
                ),
            ),
        );

        $result['交易信息'] = array
        (
            'type' => 'info',
            'content' => array
            (
                array
                (
                    array('流水号', $info['order_num']),
                    array('交易时间', $cdate),
                    array('交易类型', $type),
                ),

                array
                (
                    array('交易金额', '¥' . $info['cash'] . '元'),
                    array('交易后账户余额', '¥' . $info['yue'] . '元'),
                    array('交易说明', $info['desc']),
                ),
            )
        );

        $result['审核信息'] = array
        (
            'type' => 'info',
            'content' => array
            (
                array
                (
                    array('审核时间', $opertime),
                    array('审核状态', $status),
                    array('备注', $info['audit_desc']),
                ),
            )
        );
        
        # 提现信息

        $button = array();
        if ($info['status'] == 1) {
            $button[] = array
            (
                'type' => 'edit',
                'link' => Dever::url('project/database/update?project=bill&table=cash&where_id='.$info['id'].'&col=audit,audit_desc&oper_save_jump=cash&oper_table=cash&oper_parent=cash', 'manage'),
                'name' => '审核',
            );
        }
        if ($info['type'] == 11) {
            $tixian = Dever::db('bill/tixian')->find($info['type_id']);
            if ($tixian) {

                if ($info['status'] == 2 && $tixian['status'] == 1) {
                    $button[] = array
                    (
                        'type' => 'edit',
                        'link' => Dever::url('project/database/update?project=bill&table=tixian&where_id='.$tixian['id'].'&col=audit,audit_desc,pic&oper_save_jump=tixian&oper_table=tixian&oper_parent=tixian', 'manage'),
                        'name' => '发放',
                    );
                }

                $bank = Dever::db('setting/bank')->find($tixian['bank']);
                $result['提现信息'] = array
                (
                    'type' => 'info',
                    'content' => array
                    (
                        array
                        (
                            array('银行名称', $bank['name']),
                            array('开户行', $tixian['bankname']),
                        ),

                        array
                        (
                            array('姓名', $tixian['name']),
                            array('卡号', $tixian['card']),
                        ),
                    )
                );

                if ($tixian['status'] == 2) {
                    if ($tixian['operdate']) {
                        $opertime = date('Y-m-d H:i', $tixian['operdate']);
                    } else {
                        $opertime = '';
                    }
                    $pic = '';
                    if ($tixian['pic']) {
                        $temp = explode(',', $tixian['pic']);
                        foreach ($temp as $k => $v) {
                            $pic .= '<a href="'.Dever::pic($v).'" target="_blank"><img src="'.Dever::pic($v).'" width="150" /></a>';
                        }
                    }
                    $result['发放信息'] = array
                    (
                        'type' => 'info',
                        'content' => array
                        (
                            array
                            (
                                array('发放时间', $opertime),
                                array('备注', $tixian['audit_desc']),
                            ),
                            array
                            (
                                array('凭证', $pic),
                            ),
                        )
                    );
                }
                
            }
        }

        $head = array
        (
            'name' => '基本信息',
            'btn' => $button,
        );
        $html = Dever::show($head, $result);

        return $html;
    }
}